Skip to main content

Redeem token

POST 

/cdx/v1/shared-tokens:redeem

General Availability

Redeem the shared token for shared topic and cluster access information

Request

Responses

Consumer redeems shared token

OpenAPI definition (YAML)
paths:
  /cdx/v1/shared-tokens:redeem:
    post:
      description: '[![General Availability](https://img.shields.io/badge/Lifecycle%20Stage-General%20Availability-%2345c6e8)](#section/Versioning/API-Lifecycle-Policy)


        Redeem the shared token for shared topic and cluster access information'
      requestBody:
        content:
          application/json:
            schema:
              allOf:
              - type: object
                description: Redeem share with token request parameters
                properties:
                  metadata:
                    allOf:
                    - description: ObjectMeta is metadata that all persisted resources must have, which
                        includes all objects users must create.
                      properties: {}
                      readOnly: true
                      title: ObjectMeta
                    - properties:
                        self:
                          example: https://api.confluent.cloud/cdx/v1/redeem-token-requests/rtr-12345
                        resource_name:
                          example: crn://confluent.cloud/organization=9bb441c4-edef-46ac-8a41-c49e44a3fd9a/redeem-token-request=rtr-12345
                  token:
                    type: string
                    description: The encrypted token
                  aws_account:
                    type: string
                    description: Consumer's AWS account ID for PrivateLink access.
                    example: '000000000000'
                  azure_subscription:
                    type: string
                    description: Consumer's Azure subscription ID for PrivateLink access.
                    example: 00000000-0000-0000-0000-000000000000
                  gcp_project:
                    type: string
                    minLength: 1
                    description: Consumer's GCP project ID for Private Service Connect access.
                title: cdx.v1.RedeemTokenRequest
              - type: object
                required:
                - token
      x-lifecycle-stage: General Availability
      x-self-access: true
      x-name: cdx.v1.SharedToken
      operationId: redeemCdxV1SharedToken
      tags:
      - Shared Tokens (cdx/v1)
      security:
      - cloud-api-key: []
      responses:
        '200':
          description: 'Consumer redeems shared token

            '
          content:
            application/json:
              schema:
                type: object
                description: Share details for the consumer org or user
                properties:
                  api_version:
                    type: string
                    enum:
                    - cdx/v1
                    description: APIVersion defines the schema version of this representation of a resource.
                    readOnly: true
                  kind:
                    type: string
                    description: Kind defines the object this REST resource represents.
                    readOnly: true
                    enum:
                    - RedeemTokenResponse
                  id:
                    description: ID is the "natural identifier" for an object within its scope/namespace;
                      it is normally unique across time but not space. That is, you can assume that the
                      ID will not be reclaimed and reused after an object is deleted ("time"); however,
                      it may collide with IDs for other object `kinds` or objects of the same `kind` within
                      a different scope/namespace ("space").
                    type: string
                    maxLength: 255
                    readOnly: true
                    example: dlz-f3a90de
                  metadata:
                    allOf:
                    - description: ObjectMeta is metadata that all persisted resources must have, which
                        includes all objects users must create.
                      required:
                      - self
                      properties:
                        self:
                          description: Self is a Uniform Resource Locator (URL) at which an object can
                            be addressed. This URL encodes the service location, API version, and other
                            particulars necessary to locate the resource at a point in time
                          type: string
                          format: uri
                          readOnly: true
                          example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                        resource_name:
                          description: Resource Name is a Uniform Resource Identifier (URI) that is globally
                            unique across space and time. It is represented as a Confluent Resource Name
                          type: string
                          format: uri
                          readOnly: true
                          example: crn://confluent.cloud/kafka=lkc-f3a90de
                        created_at:
                          type: string
                          format: date-time
                          example: '2006-01-02T15:04:05-07:00'
                          readOnly: true
                          description: The date and time at which this object was created. It is represented
                            in RFC3339 format and is in UTC.
                        updated_at:
                          type: string
                          format: date-time
                          example: '2006-01-02T15:04:05-07:00'
                          readOnly: true
                          description: The date and time at which this object was last updated. It is
                            represented in RFC3339 format and is in UTC.
                        deleted_at:
                          type: string
                          format: date-time
                          example: '2006-01-02T15:04:05-07:00'
                          readOnly: true
                          description: The date and time at which this object was (or will be) deleted.
                            It is represented in RFC3339 format and is in UTC.
                      readOnly: true
                      title: ObjectMeta
                    - properties:
                        self:
                          example: https://api.confluent.cloud/cdx/v1/redeem-token-responses/rtr-12345
                        resource_name:
                          example: crn://confluent.cloud/organization=9bb441c4-edef-46ac-8a41-c49e44a3fd9a/redeem-token-response=rtr-12345
                  api_key:
                    type: string
                    description: The api key
                    readOnly: true
                  secret:
                    type: string
                    description: The api key secret
                    x-redact: true
                    readOnly: true
                  kafka_bootstrap_url:
                    type: string
                    format: uri
                    description: The kafka cluster bootstrap url
                    example: SASL://pkc-xxxxx.us-west-2.aws.confluent.cloud:9092
                    x-immutable: true
                    readOnly: true
                  schema_registry_api_key:
                    type: string
                    description: The api key for schema registry
                    readOnly: true
                  schema_registry_secret:
                    type: string
                    description: The api key secret for schema registry
                    x-redact: true
                    readOnly: true
                  schema_registry_url:
                    type: string
                    format: uri
                    description: The schema registry endpoint url
                    example: https://psrc-xxxxx.us-west-2.aws.confluent.cloud
                    x-immutable: true
                    readOnly: true
                  resources:
                    type: array
                    minItems: 1
                    description: List of shared resources
                    items:
                      type: object
                      discriminator:
                        propertyName: kind
                        mapping:
                          Topic:
                            type: object
                            description: The shared resource details
                            required:
                            - kind
                            - topic
                            properties:
                              kind:
                                description: The shared resource kind
                                type: string
                                enum:
                                - Topic
                              topic:
                                type: string
                                description: The topic name
                            title: cdx.v1.SharedTopic
                          Group:
                            type: object
                            description: The shared consumer group
                            required:
                            - kind
                            - group_prefix
                            properties:
                              kind:
                                description: The resource kind
                                type: string
                                enum:
                                - Group
                              group_prefix:
                                type: string
                                description: The consumer group prefix
                            title: cdx.v1.SharedGroup
                          Subject:
                            type: object
                            description: The shared resource details
                            required:
                            - kind
                            - subject
                            properties:
                              kind:
                                description: The shared resource kind
                                type: string
                                enum:
                                - Subject
                              subject:
                                type: string
                                description: The subject name
                            title: cdx.v1.SharedSubject
                      oneOf:
                      - type: object
                        description: The shared resource details
                        required:
                        - kind
                        - topic
                        properties:
                          kind:
                            description: The shared resource kind
                            type: string
                            enum:
                            - Topic
                          topic:
                            type: string
                            description: The topic name
                        title: cdx.v1.SharedTopic
                      - type: object
                        description: The shared consumer group
                        required:
                        - kind
                        - group_prefix
                        properties:
                          kind:
                            description: The resource kind
                            type: string
                            enum:
                            - Group
                          group_prefix:
                            type: string
                            description: The consumer group prefix
                        title: cdx.v1.SharedGroup
                      - type: object
                        description: The shared resource details
                        required:
                        - kind
                        - subject
                        properties:
                          kind:
                            description: The shared resource kind
                            type: string
                            enum:
                            - Subject
                          subject:
                            type: string
                            description: The subject name
                        title: cdx.v1.SharedSubject
                title: cdx.v1.RedeemTokenResponse
        '400':
          description: Bad Request
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '400'
                  code: invalid_filter
                  title: Invalid Filter
                  detail: The 'delorean' resource can't be filtered by 'num_doors'
                  source:
                    parameter: num_doors
        '401':
          x-summary: Unauthorized
          description: The request lacks valid authentication credentials for this resource.
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            WWW-Authenticate:
              schema:
                type: string
              description: The unique identifier for the API request.
              example: Basic error="invalid_key", error_description="The API Key is invalid"
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '401'
                  code: user_unauthenticated
                  title: Authentication Required
                  detail: Valid authentication credentials must be provided
        '403':
          x-summary: Forbidden
          description: The access credentials were considered insufficient to grant access
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '403'
                  code: user_unauthorized
                  title: User Access Unauthorized
                  detail: The user 'mcfly' is not allowed to access the 'delorean' resource without the
                    'plutonium' role.
        '404':
          description: Not Found
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '404'
                  title: Not Found
        '409':
          x-summary: Conflict
          description: The request is in conflict with the current server state
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            Location:
              schema:
                type: string
                format: uri
                example: https://api.confluent.cloud/{object}/{id}
              description: Resource URI of conflicting resource
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '409'
                  code: resource_already_exists
                  title: Resource Already exists
                  detail: The entitlement '91e3e86f-fca6-4f14-98f5-a48e64113ce2' already exists.
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Oops, something went wrong!
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '500'
                  code: out_of_gas
                  title: DeLorean Out Of Gas
                  detail: The DeLorean has run out of gas, but Doc Brown will fill 'er up for you asap
      servers:
      - url: https://api.confluent.cloud
        description: Confluent Cloud API
      jsonRequestBodyExample:
        token: string
        aws_account: '000000000000'
        azure_subscription: 00000000-0000-0000-0000-000000000000
        gcp_project: string